/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


/*****************************************************************************
******************************************************************************
**                                                                            
**        Y     Y   OOOO    OOOO   DDDDD     AA
**         Y   Y   O    O  O    O  D    D   A  A
**          Y Y    O    O  O    O  D    D  A    A 
**           Y     O    O  O    O  D    D  AAAAAA
**           Y     O    O  O    O  D    D  A    A
**           Y      OOOO    OOOO   DDDDD   A    A
**
******************************************************************************
******************************************************************************/
/*****************************************************************************
*
*  MODULE :             Interface to Collections
*  SCOPE :              Interface to Collections
*  FILE :               colx.hxx
*  AUTHORS :            E. Abecassis
*  CREATION DATE :      August 1, 1993
*  COPYRIGHTS :        (C) E. Abecassis, 1993
*  HISTORY :
*
******************************************************************************/

#ifdef __GNUG__
#pragma interface
#endif
#ifndef __colx_HXX
#define __colx_HXX

/* IMPORTS *******************************************************************/

#ifndef __col_HXX
#include "col.hxx"
#endif

/*****************************************************************************/

class LocalColX {

protected :

  Ref<Collection> _col ;

  // Verify domain for insertion
  void domainI(int ind) const ;

  // Verify domain for other manipulations
  void domainG(int ind) const ;

public :

  LocalColX() { if (YOO_LOAD_TIME == FALSE) _col = NULL ; }
  ~LocalColX() { this->clear() ; }

  // Return embeeded collection
  Ref<Collection> col() const { return _col ; }

  // Return cardinality
  int count() const { return (_col == NULL) ? 0 : _col->count() ; }

  // Empty collection
  void clear() { if (_col != NULL) this->_col->clear() ; _col = NULL ; }

  void __yoobuild(OID oid) { this->_col = oid ; }
} ;


#endif

